#include <libps.h>
#include "dumpaddr.h"
#include "pad.h"

#define OT_RES 8
#define NONINTERLACED	0
#define INTERLACED	1
#define GTEDB		0
#define GPUDB		4
#define NODITHER	0
#define DITHER		1
#define VRAM16		0
#define VRAM24		1

static int Page;
static PACKET WorkBase[2][2048];
static GsOT   WorldOrder[2];		// one for each buffer
static GsOT_TAG __OT[2][1<<OT_RES];

volatile unsigned char *__Pad1, *__Pad2;


GsIMAGE Frames;
//
// load frames
//
void LoadTim (unsigned long *tim){
  RECT dest;

  GsGetTimInfo (tim+1, &Frames);

  dest.x = Frames.px; dest.y = Frames.py;
  dest.w = Frames.pw; dest.h = Frames.ph;
  LoadImage (&dest, Frames.pixel);
  //DrawSync(0);

  if (Frames.pmode & 0x8){		// has clut?
      dest.x = Frames.cx = 320; dest.y = Frames.cy = 256;
      dest.w = Frames.cw; dest.h = Frames.ch;
      LoadImage (&dest, Frames.clut);
      //DrawSync(0);
  }
  return;
}

//
// Init Pad
//

void InitPad(void){
  GetPadBuf (&__Pad1, &__Pad2);
}

void SetActivePage(void){
    Page = GsGetActiveBuff();
}

long lzhaddr[] = {
B0_ADDR,
B1_ADDR,
B2_ADDR,
B3_ADDR,
B4_ADDR,
B5_ADDR,
B6_ADDR,
B7_ADDR,
B8_ADDR,
B9_ADDR,
B10_ADDR,
B11_ADDR,
B12_ADDR,
B13_ADDR,
B14_ADDR,
B15_ADDR,
B16_ADDR,
B17_ADDR,
B18_ADDR,
B19_ADDR,
B20_ADDR,
B21_ADDR,
B22_ADDR,
B23_ADDR,
B24_ADDR,
B25_ADDR,
B26_ADDR,
B27_ADDR,
B28_ADDR,
B29_ADDR,
B30_ADDR,
B31_ADDR,
B32_ADDR,
B33_ADDR,
B34_ADDR,
B35_ADDR,
B36_ADDR,
B37_ADDR,
B38_ADDR,
B39_ADDR,
B40_ADDR,
B41_ADDR,
B42_ADDR,
B43_ADDR,
B44_ADDR,
B45_ADDR,
B46_ADDR,
B47_ADDR,
B48_ADDR,
B49_ADDR,
B50_ADDR,
B51_ADDR,
B52_ADDR,
B53_ADDR,
B54_ADDR,
B55_ADDR,
B56_ADDR,
B57_ADDR,
B58_ADDR,
B59_ADDR,
B60_ADDR,
B61_ADDR,
B62_ADDR,
B63_ADDR,
B64_ADDR,
B65_ADDR,
B66_ADDR,
B67_ADDR,
B68_ADDR,
B69_ADDR,
B70_ADDR,
B71_ADDR,
B72_ADDR,
B73_ADDR,
B74_ADDR,
B75_ADDR,
B76_ADDR,
B77_ADDR,
B78_ADDR,
B79_ADDR,
B80_ADDR,
B81_ADDR,
B82_ADDR,
B83_ADDR,
B84_ADDR,
B85_ADDR,
B86_ADDR,
B87_ADDR,
B88_ADDR,
B89_ADDR,
B90_ADDR,
B91_ADDR,
B92_ADDR,
B93_ADDR,
B94_ADDR,
B95_ADDR,
B96_ADDR,
B97_ADDR,
B98_ADDR,
B99_ADDR,
B100_ADDR,
B101_ADDR,
B102_ADDR,
B103_ADDR,
B104_ADDR,
B105_ADDR,
B106_ADDR,
B107_ADDR,
B108_ADDR,
B109_ADDR,
B110_ADDR,
B111_ADDR,
B112_ADDR,
B113_ADDR,
B114_ADDR,
B115_ADDR,
B116_ADDR,
B117_ADDR,
B118_ADDR,
B119_ADDR,
B120_ADDR,
B121_ADDR,
B122_ADDR,
B123_ADDR,
B124_ADDR,
B125_ADDR,
B126_ADDR,
B127_ADDR,
B128_ADDR,
B129_ADDR,
B130_ADDR,
B131_ADDR,
B132_ADDR,
B133_ADDR,
B134_ADDR,
B135_ADDR,
B136_ADDR,
B137_ADDR,
B138_ADDR,
B139_ADDR,
B140_ADDR,
B141_ADDR,
B142_ADDR,
B143_ADDR,
B144_ADDR,
B145_ADDR,
B146_ADDR,
B147_ADDR,
B148_ADDR,
B149_ADDR,
B150_ADDR,
B151_ADDR,
B152_ADDR,
B153_ADDR,
B154_ADDR,
B155_ADDR,
B156_ADDR,
B157_ADDR,
B158_ADDR,
B159_ADDR,
B160_ADDR
};

  char workspace[20*1024];

void main(void){
  int i,x;
  GsSPRITE Sprite;
  int size;
  unsigned short Pad1;
  int quit = 0;
  int inc;

  SetVideoMode (MODE_PAL);

  GsInitGraph (320, 256, NONINTERLACED | GPUDB, NODITHER, VRAM16);

  GsDefDispBuff(0,0,0,256);

  InitPad();

  VSync(2);

  WorldOrder[0].length = OT_RES;
  WorldOrder[0].org = __OT[0];
  WorldOrder[1].length = OT_RES;
  WorldOrder[1].org = __OT[1];

  GsClearOt(0,0,WorldOrder);
  GsClearOt(0,0,WorldOrder+1);

  SetActivePage();



  Sprite.attribute = 0;
  Sprite.x = 80;
  Sprite.y = 30;
  Sprite.w = 128;
  Sprite.h = 128;
  Sprite.r = 128;
  Sprite.g = 128;
  Sprite.b = 128;
  Sprite.mx = 0;
  Sprite.my = 0;
  Sprite.scalex = 5000; //ONE*2;
  Sprite.scaley = 5000;  //ONE*2;
  Sprite.rotate = 0;
  Sprite.cx = 320;
  Sprite.cy = 256;
  Sprite.u = 0;
  Sprite.v = 0;

  Pad1 = 0;

  quit = 0;
  inc = 1;
  i = 0;

  printf("\n\nGrooving Baby.\n");
  printf("Test of realtime compresssion.\n\n");
  printf("select - quit\tcircle - pause\n\n");
  printf("Code - Jim\n");
  printf("Animation - Unknown\n\n");
  printf("Your views are most welcome at...\n");
  printf("www.playstation.co.uk/~Sig1LL\n\n");


  do{

    Pad1 = (*(__Pad1+2))<<8 | *(__Pad1+3);
    if (!( Pad1 & PADselect)) {
      //printf("select\n");
      quit = 1;
    }
    do {
      Pad1 = (*(__Pad1+2))<<8 | *(__Pad1+3);
      VSync(1);
    } while (!(Pad1 & PADRright));

//    printf("i %d\n", i);

    GsSetWorkBase ((PACKET*)&WorkBase[Page]);

    GsClearOt (0,0,&WorldOrder[Page]);


    size = expand((char*)lzhaddr[i], workspace);

    LoadTim (workspace);

    Sprite.u = (Frames.px % 64)*4;
    Sprite.v = Frames.py % 256;
    Sprite.cx = 320;
    Sprite.cy = 256;
    Sprite.tpage = GetTPage (0,2, Frames.px, Frames.py);
    GsSortSprite (&Sprite, &WorldOrder[Page], 100);

    DrawSync(0);
    VSync(2);
    
    GsSwapDispBuff();

    GsSortClear(0,0,0,&WorldOrder[Page]);
    GsDrawOt(&WorldOrder[Page]);

    Page ^= 1;

    if (i == 160){
	inc = -1;
    }
    if (i==0){
	inc = 1;
    }
    i += inc;
  } while(!quit);

  VSync(50);
  ResetGraph(3);
    
}
